diff --git a/Libvirt.cs b/Libvirt.cs
index 0a18328..dcba9b3 100644
--- a/Libvirt.cs
+++ b/Libvirt.cs
@@ -1399,11 +1411,11 @@ namespace LibvirtBindings
         /// <returns>
         /// 0 on success, -1 on failure
         /// </returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern int virStoragePoolGetAutostart(IntPtr pool, out int autotart);
 
         /// <summary>
-        /// Provides the connection pointer associated with a storage pool. The reference counter on the connection is not increased by this call.
+        /// Provides the connection pointer associated with a storage pool. The reference counter on the connection is not increased by this call. 
         /// WARNING: When writing libvirt bindings in other languages, do not use this function. Instead, store the connection and the pool object together.
         /// </summary>
         /// <param name="pool">
@@ -1412,7 +1424,7 @@ namespace LibvirtBindings
         /// <returns>
         /// A <see cref="IntPtr"/>the virConnectPtr or NULL in case of failure.
         /// </returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern IntPtr virStoragePoolGetConnect(IntPtr pool);
 
         /// <summary>
@@ -1427,7 +1439,7 @@ namespace LibvirtBindings
         /// <returns>
         /// 0 on success, or -1 on failure.
         /// </returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern int virStoragePoolGetInfo(IntPtr pool, ref virStoragePoolInfo info);
 
         /// <summary>
@@ -1439,8 +1451,8 @@ namespace LibvirtBindings
         /// <returns>
         /// The name of the pool, or NULL on error.
         /// </returns>
-        [DllImport("libvirt-0.dll")]
-        [return: MarshalAs(UnmanagedType.AnsiBStr)]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
+        [return: MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(StringWithoutNativeCleanUpMarshaler))]
         public static extern string virStoragePoolGetName(IntPtr pool);
 
         /// <summary>
@@ -1455,7 +1467,7 @@ namespace LibvirtBindings
         /// <returns>
         /// 0 on success, or -1 on error
         /// </returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern int virStoragePoolGetUUID(IntPtr pool, [Out] char[] uuid);
 
         /// <summary>
@@ -1470,7 +1482,7 @@ namespace LibvirtBindings
         /// <returns>
         /// 0 on success, or -1 on error.
         /// </returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         private static extern int virStoragePoolGetUUIDString(IntPtr pool, [Out] char[] uuid);
 
         ///<summary>
@@ -1487,7 +1499,7 @@ namespace LibvirtBindings
             return new string(uuidArray);
         }
         /// <summary>
-        /// Fetch an XML document describing all aspects of the storage pool.
+        /// Fetch an XML document describing all aspects of the storage pool. 
         /// This is suitable for later feeding back into the virStoragePoolCreateXML method.
         /// </summary>
         /// <param name="pool">
@@ -1499,8 +1511,8 @@ namespace LibvirtBindings
         /// <returns>
         /// A XML document, or NULL on error.
         /// </returns>
-        [DllImport("libvirt-0.dll")]
-        [return: MarshalAs(UnmanagedType.AnsiBStr)]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
+        [return: MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(StringWithoutNativeCleanUpMarshaler))]
         public static extern string virStoragePoolGetXMLDesc(IntPtr pool, virDomainXMLFlags flags);
 
         /// <summary>
@@ -1512,7 +1524,7 @@ namespace LibvirtBindings
         /// <returns>
         /// 1 if running, 0 if inactive, -1 on error.
         /// </returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern int virStoragePoolIsActive(IntPtr pool);
 
         /// <summary>
@@ -1524,7 +1536,7 @@ namespace LibvirtBindings
         /// <returns>
         /// 1 if persistent, 0 if transient, -1 on error.
         /// </returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern int virStoragePoolIsPersistent(IntPtr pool);
 
         /// <summary>
@@ -1542,7 +1554,7 @@ namespace LibvirtBindings
         /// <returns>
         /// The number of names fetched, or -1 on error.
         /// </returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         private static extern int virStoragePoolListVolumes(IntPtr pool, IntPtr names, int maxnames);
         /// <summary>
         /// Fetch list of storage volume names, limiting to at most maxnames.
@@ -1580,7 +1592,7 @@ namespace LibvirtBindings
         /// <returns>
         /// A <see cref="IntPtr"/>virStoragePoolPtr object, or NULL if no matching pool is found.
         /// </returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern IntPtr virStoragePoolLookupByName(IntPtr conn, string name);
 
         /// <summary>
@@ -1595,7 +1607,7 @@ namespace LibvirtBindings
         /// <returns>
         /// A virStoragePoolPtr object, or NULL if no matching pool is found
         /// </returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern IntPtr virStoragePoolLookupByUUID(IntPtr conn, char[] uuid);
 
         /// <summary>
@@ -1610,7 +1622,7 @@ namespace LibvirtBindings
         /// <returns>
         /// A <see cref="IntPtr"/>object, or NULL if no matching pool is found.
         /// </returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern IntPtr virStoragePoolLookupByUUIDString(IntPtr conn, string uuidstr);
 
         /// <summary>
@@ -1622,7 +1634,7 @@ namespace LibvirtBindings
         /// <returns>
         /// A <see cref="IntPtr"/>object, or NULL if no matching pool is found.
         /// </returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern IntPtr virStoragePoolLookupByVolume(IntPtr vol);
 
         /// <summary>
@@ -1634,15 +1646,15 @@ namespace LibvirtBindings
         /// <returns>
         /// A <see cref="System.Int32"/>the number of storage pools, or -1 on failure.
         /// </returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern int virStoragePoolNumOfVolumes(IntPtr pool);
 
         /// <summary>
-        /// Increment the reference count on the pool. For each additional call to this method,
-        /// there shall be a corresponding call to virStoragePoolFree to release the reference count,
-        /// once the caller no longer needs the reference to this object.
-        /// This method is typically useful for applications where multiple threads are using a connection,
-        /// and it is required that the connection remain open until all threads have finished using it. ie,
+        /// Increment the reference count on the pool. For each additional call to this method, 
+        /// there shall be a corresponding call to virStoragePoolFree to release the reference count, 
+        /// once the caller no longer needs the reference to this object. 
+        /// This method is typically useful for applications where multiple threads are using a connection, 
+        /// and it is required that the connection remain open until all threads have finished using it. ie, 
         /// each new thread using a pool would increment the reference count.
         /// </summary>
         /// <param name="pool">
@@ -1651,11 +1663,11 @@ namespace LibvirtBindings
         /// <returns>
         /// 0 in case of success, -1 in case of failure.
         /// </returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern int virStoragePoolRef(IntPtr pool);
 
         /// <summary>
-        /// Request that the pool refresh its list of volumes. This may involve communicating with a remote server,
+        /// Request that the pool refresh its list of volumes. This may involve communicating with a remote server, 
         /// and/or initializing new devices at the OS layer.
         /// </summary>
         /// <param name="pool">
@@ -1682,7 +1694,7 @@ namespace LibvirtBindings
         /// <returns>
         /// 0 on success, -1 on failure.
         /// </returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern int virStoragePoolSetAutostart(IntPtr pool, int autostart);
 
         /// <summary>
@@ -1694,7 +1706,7 @@ namespace LibvirtBindings
         /// <returns>
         /// 0 on success, -1 on failure.
         /// </returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern int virStoragePoolUndefine(IntPtr pool);
         #endregion
 
@@ -1715,11 +1727,11 @@ namespace LibvirtBindings
         /// <returns>
         /// The storage volume, or NULL on error.
         /// </returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern IntPtr virStorageVolCreateXML(IntPtr pool, string xmldesc, uint flags);
 
         /// <summary>
-        /// Create a storage volume in the parent pool, using the 'clonevol' volume as input.
+        /// Create a storage volume in the parent pool, using the 'clonevol' volume as input. 
         /// Information for the new volume (name, perms) are passed via a typical volume XML description.
         /// </summary>
         /// <param name="pool">
@@ -1737,7 +1749,7 @@ namespace LibvirtBindings
         /// <returns>
         /// A <see cref="IntPtr"/>the storage volume, or NULL on error.
         /// </returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern IntPtr virStorageVolCreateXMLFrom(IntPtr pool, string xmldesc, IntPtr clonevol, uint flags);
 
         /// <summary>
@@ -1752,7 +1764,7 @@ namespace LibvirtBindings
         /// <returns>
         /// 0 on success, or -1 on error.
         /// </returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern int virStorageVolDelete(IntPtr vol, uint flags);
 
         /// <summary>
@@ -1764,13 +1776,13 @@ namespace LibvirtBindings
         /// <returns>
         /// 0 on success, or -1 on error.
         /// </returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern int virStorageVolFree(IntPtr vol);
 
         /// <summary>
-        /// Provides the connection pointer associated with a storage volume.
-        /// The reference counter on the connection is not increased by this call.
-        /// WARNING: When writing libvirt bindings in other languages, do not use this function.
+        /// Provides the connection pointer associated with a storage volume. 
+        /// The reference counter on the connection is not increased by this call. 
+        /// WARNING: When writing libvirt bindings in other languages, do not use this function. 
         /// Instead, store the connection and the volume object together.
         /// </summary>
         /// <param name="vol">
@@ -1779,7 +1791,7 @@ namespace LibvirtBindings
         /// <returns>
         /// A <see cref="IntPtr"/>
         /// </returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern IntPtr virStorageVolGetConnect(IntPtr vol);
 
         /// <summary>
@@ -1794,11 +1806,11 @@ namespace LibvirtBindings
         /// <returns>
         /// 0 on success, or -1 on failure.
         /// </returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern int virStorageVolGetInfo(IntPtr vol, ref virStorageVolInfo info);
 
         /// <summary>
-        /// Fetch the storage volume key.
+        /// Fetch the storage volume key. 
         /// This is globally unique, so the same volume will have the same key no matter what host it is accessed from
         /// </summary>
         /// <param name="vol">
@@ -1807,8 +1819,8 @@ namespace LibvirtBindings
         /// <returns>
         /// The volume key, or NULL on error.
         /// </returns>
-        [DllImport("libvirt-0.dll")]
-        [return: MarshalAs(UnmanagedType.AnsiBStr)]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
+        [return: MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(StringWithoutNativeCleanUpMarshaler))]
         public static extern string virStorageVolGetKey(IntPtr vol);
 
         /// <summary>
@@ -1820,14 +1832,14 @@ namespace LibvirtBindings
         /// <returns>
         /// The volume name, or NULL on error.
         /// </returns>
-        [DllImport("libvirt-0.dll")]
-        [return: MarshalAs(UnmanagedType.AnsiBStr)]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
+        [return: MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(StringWithoutNativeCleanUpMarshaler))]
         public static extern string virStorageVolGetName(IntPtr vol);
 
         /// <summary>
-        /// Fetch the storage volume path.
-        /// Depending on the pool configuration this is either persistent across hosts,
-        /// or dynamically assigned at pool startup.
+        /// Fetch the storage volume path. 
+        /// Depending on the pool configuration this is either persistent across hosts, 
+        /// or dynamically assigned at pool startup. 
         /// Consult pool documentation for information on getting the persistent naming.
         /// </summary>
         /// <param name="vol">
@@ -1836,8 +1848,8 @@ namespace LibvirtBindings
         /// <returns>
         /// The storage volume path, or NULL on error.
         /// </returns>
-        [DllImport("libvirt-0.dll")]
-        [return: MarshalAs(UnmanagedType.AnsiBStr)]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
+        [return: MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(StringWithoutNativeCleanUpMarshaler))]
         public static extern string virStorageVolGetPath(IntPtr vol);
 
         /// <summary>
@@ -1852,8 +1864,8 @@ namespace LibvirtBindings
         /// <returns>
         /// The XML document, or NULL on error.
         /// </returns>
-        [DllImport("libvirt-0.dll")]
-        [return: MarshalAs(UnmanagedType.AnsiBStr)]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
+        [return: MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(StringWithoutNativeCleanUpMarshaler))]
         public static extern string virStorageVolGetXMLDesc(IntPtr vol, uint flags);
 
         /// <summary>
@@ -1868,7 +1880,7 @@ namespace LibvirtBindings
         /// <returns>
         /// A <see cref="IntPtr"/>storage volume, or NULL if not found / error.
         /// </returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern IntPtr virStorageVolLookupByKey(IntPtr conn, string key);
 
         /// <summary>
@@ -1883,7 +1895,7 @@ namespace LibvirtBindings
         /// <returns>
         /// A <see cref="IntPtr"/>storage volume, or NULL if not found / error.
         /// </returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern IntPtr virStorageVolLookupByName(IntPtr pool, string name);
 
         /// <summary>
@@ -1898,15 +1910,15 @@ namespace LibvirtBindings
         /// <returns>
         /// A <see cref="IntPtr"/>storage volume, or NULL if not found / error.
         /// </returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern IntPtr virStorageVolLookupByPath(IntPtr conn, string path);
 
         /// <summary>
-        /// Increment the reference count on the vol. For each additional call to this method,
-        /// there shall be a corresponding call to virStorageVolFree to release the reference count,
-        /// once the caller no longer needs the reference to this object.
-        /// This method is typically useful for applications where multiple threads are using a connection,
-        /// and it is required that the connection remain open until all threads have finished using it. ie,
+        /// Increment the reference count on the vol. For each additional call to this method, 
+        /// there shall be a corresponding call to virStorageVolFree to release the reference count, 
+        /// once the caller no longer needs the reference to this object. 
+        /// This method is typically useful for applications where multiple threads are using a connection, 
+        /// and it is required that the connection remain open until all threads have finished using it. ie, 
         /// each new thread using a vol would increment the reference count.
         /// </summary>
         /// <param name="vol">
@@ -1915,7 +1927,7 @@ namespace LibvirtBindings
         /// <returns>
         /// A <see cref="System.Int32"/>0 in case of success, -1 in case of failure.
         /// </returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern int virStorageVolRef(IntPtr vol);
 
         #endregion
@@ -1983,7 +1995,7 @@ namespace LibvirtBindings
         /// </summary>
         /// <param name="network">pointer to a defined network</param>
         /// <returns>0 in case of success, -1 in case of error</returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern int virNetworkCreate(IntPtr network);
         /// <summary>
         /// Create and start a new virtual network, based on an XML description similar to the one returned by virNetworkGetXMLDesc()
@@ -1991,7 +2003,7 @@ namespace LibvirtBindings
         /// <param name="conn">pointer to the hypervisor connection</param>
         /// <param name="xmlDesc">an XML description of the network</param>
         /// <returns>a new network object or NULL in case of failure</returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern IntPtr virNetworkCreateXML(IntPtr conn, string xmlDesc);
         /// <summary>
         /// Define a network, but does not create it
@@ -1999,21 +2011,21 @@ namespace LibvirtBindings
         /// <param name="conn">pointer to the hypervisor connection</param>
         /// <param name="xmlDesc">the XML description for the network, preferably in UTF-8</param>
         /// <returns>NULL in case of error, a pointer to the network otherwise</returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern IntPtr virNetworkDefineXML(IntPtr conn, string xmlDesc);
         /// <summary>
         /// Destroy the network object. The running instance is shutdown if not down already and all resources used by it are given back to the hypervisor. This does not free the associated virNetworkPtr object. This function may require privileged access
         /// </summary>
         /// <param name="network">a network object</param>
         /// <returns>0 in case of success and -1 in case of failure.</returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern int virNetworkDestroy(IntPtr network);
         /// <summary>
         /// Free the network object. The running instance is kept alive. The data structure is freed and should not be used thereafter.
         /// </summary>
         /// <param name="network">a network object</param>
         /// <returns>0 in case of success and -1 in case of failure</returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern int virNetworkFree(IntPtr network);
         /// <summary>
         /// Provides a boolean value indicating whether the network configured to be automatically started when the host machine boots.
@@ -2021,30 +2033,30 @@ namespace LibvirtBindings
         /// <param name="network">a network object</param>
         /// <param name="autostart">the value returned</param>
         /// <returns>-1 in case of error, 0 in case of success</returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern int virNetworkGetAutostart(IntPtr network, int autostart);
         /// <summary>
         /// Provides a bridge interface name to which a domain may connect a network interface in order to join the network.
         /// </summary>
         /// <param name="network">a network object</param>
         /// <returns>a 0 terminated interface name, or NULL in case of error. the caller must free() the returned value</returns>
-        [DllImport("libvirt-0.dll")]
-        [return: MarshalAs(UnmanagedType.AnsiBStr)]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
+        [return: MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(StringWithoutNativeCleanUpMarshaler))]
         public static extern string virNetworkGetBridgeName(IntPtr network);
         /// <summary>
         /// Provides the connection pointer associated with a network. The reference counter on the connection is not increased by this call. WARNING: When writing libvirt bindings in other languages, do not use this function. Instead, store the connection and the network object together
         /// </summary>
         /// <param name="network">pointer to a network</param>
         /// <returns>the virConnectPtr or NULL in case of failure</returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern IntPtr virNetworkGetConnect(IntPtr network);
         /// <summary>
         /// Get the public name for that network
         /// </summary>
         /// <param name="network">a network object</param>
         /// <returns>a pointer to the name or NULL, the string need not be deallocated its lifetime will be the same as the network object</returns>
-        [DllImport("libvirt-0.dll")]
-        [return: MarshalAs(UnmanagedType.AnsiBStr)]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
+        [return: MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(StringWithoutNativeCleanUpMarshaler))]
         public static extern string virNetworkGetName(IntPtr network);
         /// <summary>
         /// Get the UUID for a network as string
@@ -2052,7 +2064,7 @@ namespace LibvirtBindings
         /// <param name="network">a network object</param>
         /// <param name="uuid">string of the uuid</param>
         /// <returns>-1 in case of error, 0 in case of success</returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         private static extern int virNetworkGetUUIDString(IntPtr network, [Out] char[] uuid);
 
         ///<summary>
@@ -2072,22 +2084,22 @@ namespace LibvirtBindings
         /// <param name="network">a network object</param>
         /// <param name="flags">an OR'ed set of extraction flags, not used yet</param>
         /// <returns>a 0 terminated UTF-8 encoded XML instance, or NULL in case of error. the caller must free() the returned value</returns>
-        [DllImport("libvirt-0.dll")]
-        [return: MarshalAs(UnmanagedType.AnsiBStr)]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
+        [return: MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(StringWithoutNativeCleanUpMarshaler))]
         public static extern string virNetworkGetXMLDesc(IntPtr network, int flags);
         /// <summary>
         /// Determine if the network is currently running
         /// </summary>
         /// <param name="network">pointer to the network object</param>
         /// <returns>1 if running, 0 if inactive, -1 on error</returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern int virNetworkIsActive(IntPtr network);
         /// <summary>
         /// Determine if the network has a persistent configuration which means it will still exist after shutting down
         /// </summary>
         /// <param name="network">pointer to the network object</param>
         /// <returns>x1 if persistent, 0 if transient, -1 on error</returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern int virNetworkIsPersistent(IntPtr network);
         /// <summary>
         /// Try to lookup a network on the given hypervisor based on its name.
@@ -2095,7 +2107,7 @@ namespace LibvirtBindings
         /// <param name="conn">pointer to the hypervisor connection</param>
         /// <param name="name">name for the network</param>
         /// <returns>a new network object or NULL in case of failure. If the network cannot be found, then VIR_ERR_NO_NETWORK error is raised</returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern IntPtr virNetworkLookupByName(IntPtr conn, string name);
         /// <summary>
         /// Try to lookup a network on the given hypervisor based on its UUID
@@ -2103,7 +2115,7 @@ namespace LibvirtBindings
         /// <param name="conn">pointer to the hypervisor connection</param>
         /// <param name="uuidstr">the string UUID for the network</param>
         /// <returns>a new network object or NULL in case of failure. If the network cannot be found, then VIR_ERR_NO_NETWORK error is raised</returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern IntPtr virNetworkLookupByUUIDString(IntPtr conn, string uuidstr);
         /// <summary>
         /// Configure the network to be automatically started when the host machine boots
@@ -2111,20 +2123,20 @@ namespace LibvirtBindings
         /// <param name="network">a network object</param>
         /// <param name="autostart">whether the network should be automatically started 0 or 1</param>
         /// <returns>-1 in case of error, 0 in case of success</returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern int virNetworkSetAutostart(IntPtr network, int autostart);
         /// <summary>
         /// Undefine a network but does not stop it if it is running
         /// </summary>
         /// <param name="network">pointer to a defined network</param>
         /// <returns>0 in case of success, -1 in case of error</returns>
-        [DllImport("libvirt-0.dll")]
+        [DllImport(LibvirtDllImportName, CallingConvention=CallingConvention.Cdecl)]
         public static extern int virNetworkUndefine(IntPtr network);
 
         #endregion
 
         #region Helpers
-
+        
         private static string[] ptrToStringArray(IntPtr stringPtr, int stringCount)
         {
             string[] members = new string[stringCount];
